#include "allusionary.h"

allusion_t allusion[NUM_ALLUSIONS]={
	{"Alien Blood",	
	 "A reference to the Alien(s) movie series.  In that movie, the aliens bled acid that would burn through things, so that is just what you do when you drink this delicious treat.",
	},
	{"All Up In Your Grill",
 	 "(From the Throwing skill description)  I don't actually know what this is a reference to.  It's just a bit of incredibly stupid slang that we sometimes use around here for fun.  Grill means \"mouth\" literally (Or maybe it means face, but I thought it was mouth), so this phrase means \"in your face\", as in invasive and into your business, though it can also literally mean getting in someone's face, which is how it is used in the game.  Use the throwing skill to avoid having to get close to enemies!"
	},
	{"Asbestos Underwear",	
	 "Asbestos is of course a flame retardant (and highly toxic) material.  On the internet, people sometimes say they are putting on their asbestos underwear when they have said something controversial.  This means they are preparing themselves for the flames (insults/attacks) they expect to be coming."
	},
	{"Axes R Us", 
	 "This obviously refers to the toy store chain \"Toys 'R' Us\", although there are many other stores in the real world that have also stolen the naming convention and terrible grammar, like Tools-R-Us."
	},
	{"Ballooning", 
	 "You'll notice when using Phileas' balloon service that he will only take you to places you've been before.  This is standard in such games - can't let the player just teleport to new places!  The balloon is instead a shortcut to avoid repetition.  An attempt to rationalize this is made by Phileas.  Apparently he is so forgetful that he needs you to describe in detail where you are going, and you can't do that if you haven't been there.  It's a shame he won't just let you wander around in the balloon, maybe find some hidden stuff!"
	},
	{"Baskerville",
	 "You meet the Ice Hounds here, a reference to \"The Hound Of The Baskervilles\", a Sherlock Holmes story by (surprisingly) Sir Arthur Conan Doyle. Only this time it's houndS, and just one Baskerville."
	},
	{"Bear Room Brawl",
	 "This is a reference to the common phrase \"bar room brawl\", only this isn't a bar, it's a room full of bears.  Secondly, the description says it's a necessity that you slay the bears.  This is an oblique and weak reference to the phrase \"the bare necessities\", which is so often redone as \"the bear necessities\" for various cartoon purposes.",
	},
	{"Beowulf", 
	 "From the Axe Mastery skill description.  This is not a reference to classic literature at all, but rather to the song \"Let's Build A Snowman\" from Cannibal: The Musical, in which the singer declares \"So, let's build a snowman, we can make him our best friend, We can name him Bob, or we can name him Beowulf!  We can make him tall or we can make him not-so-tall!  Snowman!\"  No, it doesn't rhyme or have much rhythm.  It's just very funny.",
	},
	{"Black Market Bob",
	 "There is no reason this guy is named Bob other than that it starts with a B and sounds goofy.  It's just the name that came to me when I needed a black market character.  Why did I need one?  So I could totally rip off the \"gambling\" feature (which is so not gambling) in Diablo 2.  Which I did."
	},
	{"Blunderdome",
	 "The second reference to Mad Max 3: Beyond Thunderdome in the game.  The first was Tina herself.  The third is Beyond Blunderdome.",
	},
	{"Bobby Joe",
	 "Just a name that sounds like a child, and very unfantasy style.  Which is important to me.  I want to subvert expectations where possible.  Man, that kid has an awful haircut.",
	},
	{"Bodzha",
	 "This monster's name is phonetically almost identical to \"badger\" as pronounced by a British person.  I based the monster on badgers, because I needed a monster with big claws, and so I could name one the Stinkin' Bodzha, but I also wanted an original name so I could carry the monster on into Loonyland history.  I mean, it's clearly not a badger...  Stinkin' Bodzha is a reference to the line \"We don't need no stinkin' badgers!\" from the Weird Al movie UHF, which is itself a parody of \"We don't need no stinkin' badges\" in Treasure Of The Sierra Madre."
	},
	{"Bonehead",
	 "Obviously a common insult indicating someone is unintelligent, neatly juxtaposed with the fact that, as skeletons, these guys have heads made entirely of bone.  These monsters are from Dr. Lunatic (and Loonyland, Spooky Castle, and... well, it's a long list).  They're brought back here specifically only for Loony to use, kind of a post-foreshadowing of his future as Dr. Lunatic.  Very postmodern.",
	},
	{"Bop Em On The Head",
	 "This quest name is a reference to the creepy children's song \"Little Bunny Foo-Foo\" who hops through the forest, scooping up field mice and bopping them on the head.  I made the reference thinking it was a bear that bopped bunnies on the head, so it's not a very good reference after all.",
	},
	{"Bubbleweed",
	 "You notice how the herb names are a bit odd?  That's because I came up with Asbestos (for the asbestos underwear) and Frostbane (because it seemed appropriate to the winter environment), and then discovered that to have 20 potions, I needed exactly 6 herbs.  Thus I realized I could have herbs with initials from A to F!  Brilliant!!  Bubbleweed is just a name that came to me looking for B's, then the idea of making it grow in riverbanks was obvious and gives it a little realism.",
	},
	{"Burly Brawl",
	 "This is a reference to the fight in The Matrix Reloaded, when Neo battles dozens of copies of Agent Smith at once.  I don't know how the term entered popular conversation, since it's not called that in the movie, but apparently the effects team called it the burly brawl, and everyone else does too.  It's also the name of the song on the soundtrack pertaining to that scene.",
	},
	{"Burninate",
	 "This is how Trogdor the dragon describes destroying peasant villages via fire.  Trogdor is a cartoon invention of Strongbad, who himself is a cartoon invention of the Brothers Chaps, featured on Homestar Runner (a web cartoon).  This skill also references Kid Mystic (a Hamumu character) directly in its description, because Kid Mystic never paid attention in magic class except for fireballs, the one kind of magic he really likes.  Lastly, the description says \"asplodes\" instead of \"explodes\", another Strongbad reference.",
	},
	{"Cave Bear",
	 "The book \"Clan Of The Cave Bear\" by Jean M. Auel.  Never read it, but nonetheless I'm sure this is a very accurate portrayal.",
	},
	{"Cereal",
	 "When Curaga tells you she is being \"totally cereal\", that's actually a South Park reference.  On South Park, for no reason I can fathom, they had Al Gore repeatedly using the word cereal in place of serious, making him sound like a preteen girl.  Curaga shares this particular affectation.",
	},
	{"Cilantro",
	 "My dad really hates cilantro.  I don't particularly like it myself.  This is a nice herb to include because what other fantasy game includes cilantro as an herb?",
	},
	{"Cool-Ade", 
	 "A very blunt reference to the drink Kool-Aid, but with the subtle changes needed to avoid lawsuits, and to make it very clearly about \"cool\", which is to say freezing enemies that get close.",
	},
	{"Cryozoid",
	 "Another Hamumu reference.  These monsters are in Dr. Lunatic, and they're brought back here, since you are in fact a young Dr. Lunatic.  Note that these, Boneheads, and Shrooms are the ONLY monsters or items in the entire game that are brought in from another game.  This was an artistic choice, to say \"You are Dr. Lunatic, so this is what you know how to do.\"  The description of this skill is just meant to be vaguely Lovecraftian, to make them sound horribly frightful, until you see that they're fuzzy.",
	},
	{"Crystal Quest",
	 "A very direct and clear name for the quest, and also the name of a video game.",
	},
	{"Curaga",
	 "Like her sister Healiana, Curaga is named after the act of healing.  However, her name is directly lifted from the Final Fantasy game series.  In that game, oddly, spells get more powerful by adding the suffixes '-ra' and then '-ga' to them.  So the Cure spell upgrades to Cura, which then reaches the ultimate form as Curaga.  Hence the name.",
	},
	{"Devil Grass",
	 "This herb is referenced a few times in Stephen King's Dark Tower series.  Always good to have a shout-out to Stephen King!  The description of devil grass in-game refers to the thing I most commonly associate with LSD use - proclamations that the Earth is being invaded by giant lizard men from space.  Saw it on the Daily Show once!  Actually, they didn't say the guy saying it used LSD, I just assumed that... because he was talking about giant space lizards.",
	},
	{"Dr. Deflector",
	 "A take on Dr. Pepper.  There's a fair chance that there actually IS a drink called Dr. Deflector, because all the generic companies that try to rip off Dr. Pepper come up with the most insane names.  A classic (and disgusting) one from my college days was Dr. Smooth.  Such a cool name that a friend adopted it as a handle.  He was also the only one who dared to drink that stuff.",
	},
	{"Eau De Monster",
	 "In French, perfume is called \"eau de toilette\", which contrary to popular belief does not mean \"toilet water\".  Well, I guess it does literally.  But what it MEANS is water you apply to yourself in the bathroom, i.e. for personal grooming purposes.  Nonetheless, Eau De Monster is a delightful scent of monster, to attract monsters to you.",
	},
	{"Elderberry",
	 "This is a vague Monty Python reference.  Elderberries are a real thing, but I thought of them because of the line in Monty Python And The Holy Grail, \"Your mother was a hamster and your father smelt of elderberries!\"  I don't know what they smell like, but based on a little googling, they probably have a nice berry smell.",
	},
	{"Explosivo",
	 "A Tenacious D reference!  Explosivo is a song by Tenacious D, which isn't actually about anything.  In fact, the chorus goes \"What's the name of the song, Explosivo!  Don't know what it's about, but it's good to go.\"",
	},
	{"Factory Clearance",
	 "Often, businesses will have \"factory clearance sales\", which really means they want to clear out their warehouse, I believe.  I mean, to clear out the factory, they'd have to sell the equipment they use to make their products, not the products themselves!  Anyway, in the game, you are indeed clearing out an actual factory, proving that once again, Hamumu is more scientifically accurate than common terminology.",
	},
	{"Fear Beer",
	 "Seemingly self-explanatory, but it's actually inspired loosely by \"near beer\", the popular term for non-alcoholic beer.",
	},
	{"Festivus",
	 "The people of Winter Woods celebrate Festivus.  This is a holiday popularized on the TV show Seinfeld, although it did actually exist before that.  It is a fairly recent invention, and it's very silly.  The metal pole in the middle of Eisburg is a Festivus Pole, an actual Festivus tradition.  Feel free to Google the origins of this unique holiday.",
	},
	{"Freezing",
	 "The description of this talent says \"Icy glare, cold shoulder, assorted other ice puns.\"  What's that an allusion to?  The obnoxious way that everything in this game has to be a big joke!  Yes, I'm even mocking myself!",
	},
	{"Frostbane",
	 "Can't have a list of herbs without some kind of \"bane\" in it, right?  This is an original invention.  It is of course the bane of frost, so the villagers believe that it wards away frost somehow.  Don't know why they think that, since it grows in snow.",
	},
	{"Gale",
	 "Not a reference to anything, simply the name of exactly what it does.  But I should mention that there is a spell called Gale in the game Guild Wars which also knocks down enemies.  Mine is cooler.",
	},
	{"Gear",
	 "The gear is described as metal and solid, a lame little reference to Metal Gear Solid, a Playstation game.",
	},
	{"Geoffrey",
	 "As the proprietor of Axes R Us, it is only proper that Geoffrey should have a very long neck... he's a human version of Geoffrey the Giraffe, the mascot of Toys R Us.",
	},
	{"Ghost Dog",
	 "A very very minimal reference to the movie \"Ghost Dog: Way Of The Samurai,\" which features precisely zero undead canines.",
	},
	{"Gladiator",
	 "The description of this talent is a complex allusion.  Gladiator is of course a Russell Crowe movie, and on South Park, they poked fun at Russell Crowe by giving him a TV show wherein he and his friend the talking tugboat would travel around the world getting in brawls.  The show's song said that Russell was \"fightin' round the world.\"",
	},
	{"Going and Going...",
	 "(Piercing skill description) The phrase \"Keeps on going, and going, and going...\" is of course from Energizer commercials featuring a pink bunny.  Don't pretend you don't know it.",
	},
	{"Haggling",
	 "The idea of pinching pennies so hard you can sell them as souvenirs refers to those machines at tourist attractions.  You put a penny in them (and a quarter or more to pay for the great prize), and the machine smashes the penny, imprinting some kind of emblem on it, as a keepsake of your visit.",
	},
	{"Healiana",
	 "This name is not actually a reference to anything, but rather a play on the very overly fey and sparkly names that female healing magic people in fantasy games and literature have.  Like \"Moonmist\" or \"Alluria\".  I just took it one step further and flat out called her Healiana, because she heals.",
	},
	{"Healium",
	 "Obviously a play on \"Helium\".  But more importantly, when Healiana says she is mixing the Frostbane with 10 other secret herbs and spices, that's an allusion to the KFC secret recipe of 11 herbs and spices.",
	},
	{"Herbal Essences",
	 "I use this brand of shampoo.",
	},
	{"Hornswaggle, Lt.",
	 "If you talk to the Lt. again without completing his task, he says \"What do I look like, some kind of guy who's not lazy?\", which is a direct quote from the TV show Futurama.  His name is not a reference to anything, it just sounds funny.",
	},
	{"Ignite",
	 "There's no reference in this actual spell, but the symbol for it on the Spell Menu is an homage to those stick figure warning labels that are so amusing, with their heads on fire and whatnot.",
	},
	{"It's Not Easy",
	 "In this Arena battle, you are poisoned the entire time, making you green.  This is a reference to the Kermit The Frog song \"It's Not Easy Being Green.\"",
	},
	{"Jolting Soda",
	 "An obvious, perhaps too obvious, take on Jolt Cola.  Making it shoot electricity was a no-brainer.",
	},
	{"Junksmith",
	 "Ah, once again attaching a word to the suffix -smith has paid off!  This talent's description refers to the TV show MacGyver, in which the titular character would always build amazing weapons and tools out of tiny bits of seemingly useless junk.  Also note when junksmithing that the go button is labeled \"Smith It Good\", a reference to the Devo song \"Whip It Good.\"",
	},
	{"Klonk",
	 "Klonk is your basic troll/ogre monster.  They always have names like Ugg and Bonk.  I chose Klonk.  It is nothing more than a description of what he does with his club.",
	},
	{"Legitimate Business",
	 "Mafia people, at least in stories, always refer to themselves as \"legitimate businessmen\", and hide behind fronts of seemingly respectable businesses.  Bob is not as clever as they are, and simply puts up this sign in front of his business.  Subtlety is not his forte.",
	},
	{"Leeeroy Jenkins",
	 "This is one possible combination of Inscribed Lenses you can put in your glasses.  It is a reference to a World Of Warcraft legend, based on a joke video about a player who charges in ahead of his guild into a dangerous area, forcing them to all rush in after him and end up getting wiped out.  His name, as well as his infamous battlecry, is \"LEEEEROOOY JENKINS!\"  The effect of the lenses is designed accordingly.  Don't ask me why this is so famous, it just is.",
	},
	{"Log",
	 "The description of the Logs in the item list is a line from the song in a fake commercial for a toy called \"Log\" (which was simply a log) in the TV show Ren & Stimpy.  It also describes logs quite eloquently.",
	},
	{"Luckenbrau",
	 "A riff on the beer Lowenbrau.  Brau is German for brew, did you know?  Hence German beers are often called somethingbrau.  Which (besides a lack of creativity) is why there is also a potion called Healenbrau.  Once on the Simpsons, Homer mentioned \"Skittlebrau\", the beer with Skittles in it.",
	},
	{"Macguffins",
	 "The package for Curaga is filled with these.  What are they?  It's a classic term from moviemaking, referring to an object that has no other purpose than to move the story along - doesn't matter what's in the package, it's just the thing you need to deliver to complete the quest!  See also \"Thing Of Majig.\"",
	},
	{"Magic Box, The",
	 "The magic shop owned by Giles on Buffy The Vampire Slayer was called The Magic Box!  The proprietor of this shop is named Guy Magic, because for the longest time I just had him listed as 'Magic Guy', since I couldn't come up with a name for him.",
	},
	{"Magicsmith",
	 "This is not a reference to anything at all, it's simply my own invention.  You can put almost anything in front of the suffix -smith and make a new craft.  In this case, it's a magicsmith, who smiths magic.  In the web game Kingdom Of Loathing, there's a skill of meatsmithing, which is building things out of meat.  Kind of gross.  The Magicsmith's name is Mrs. Smith.  We never find out her first name, until now: it's Magic.  Her name is Magic Smith.",
	},
	{"Major Fishbug",
	 "A major in-joke.  My nephew Trey once drew a picture that looked like some kind of large fish-monster (he was 3, so the exact details were a bit unclear).  When asked what it was, he called it a \"major fish-bug!\"  And that is where Major Fishbug got his name.",
	},
	{"Maze Of Death, The",
	 "An obscure reference to an obscure series, the Clerks animated series.  In the pilot episode, after ascending the side of Leonardo Leonardo's office building, they are presented with two doors they can enter to get inside.  One is blank, and the other is labeled \"The Maze Of Death\".  Randal says they should take that one, because they don't know what they're getting with the other door.  This proves unwise.",
	},
	{"Melody",
	 "The only reason Bob's wife is named Melody is so that I could include this reference in a quest name: Unchain Melody.  It of course refers to the song \"Unchained Melody\" by The Righteous Brothers, which was made exceedingly popular (again) by the movie Ghost.",
	},
	{"Mickey",
	 "This villager is named Mickey only so that the quest to rid the mice from his basement could be called \"Mickey's Mice\", which is of course an allusion to a fairly well known rodent.  Mickey himself (despite his disco appearance, which was just a random notion to make him distinctive) is a play on how you always barge into everybody's house in RPGs and take what you want.  Mickey doesn't approve.",
	},
	{"Mixology",
	 "The description of this Talent mentions several different mixed drinks and says \"Shaken, not stirred.\"  That is how James Bond (of the James Bond movie series, in case you haven't heard of him) always requests his martinis.",
	},
	{"Mudder's Milk",
	 "Originally called Mighty Milk (since it boosts your strength), but changed as an homage to the best TV series ever to (briefly) exist, Firefly!  Mudder's Milk is featured in the episode \"Jaynestown\", where it is the high protein malted beverage that the people known as mudders choke down.  It also is obviously a play on the common phrase \"mother's milk.\"",
	},
	{"Offer You Can't Refuse",
	 "This is a reference to the Godfather series of movies.  Mobsters like to make people offers that they can't refuse.  Black Market Bob is not so subtly a mobster.",
	},
	{"Oh, The Pl. You've Been",
	 "A Dr. Seuss book is named \"Oh The Places You'll Go.\" so Phileas lists The Places You've Been.",
	},
	{"Phileas",
	 "This character (the guy who flies the balloon) is named after the main character Phileas Fogg in Jules Verne's \"Around The World In 80 Days\", who of course flies a hot air balloon (among other transport methods).",
	},
	{"Pine Key",
	 "The description of the Pine Key evokes those pine-tree shaped car air fresheners, which are typically hung from the mirror of a car.",
	},
	{"Punch",
	 "A popular and very well known puppet show, Punch And Judy.  Originally this monster was called Punch Sans Judy, which is more clever and amusing, but also much too long and unwieldy.",
	},
	{"Random Gibberish",
	 "This is what is literally written on the generic signs you see everywhere, that you can bump into for different messages.  It's a reference to how so many games do this same thing - a sign that clearly has some random gibberish printed on it (the same gibberish on every sign!), and yet when you read it, you read something entirely different.",
	},
	{"Ratatouille",
	 "You see, it's a rat... and the word ratatouille begins with \"rat\"!  Brilliant!!  Ratatouille is of course a French dish, some sort of vegetable casserole.  The \"touille\" part sounds like \"ptooey\" to me, so probably it should've shot things at you, but I thought the dashing attack was a nice twist - a boss you could easily defeat if you figured out how.  Actually, you pretty much can easily defeat him, end of story.",
	},
	{"Red Cow",
	 "The energy drink that gives you wings (doubles your speed, technically)!  A reference to Red Bull, the energy drink. Probably a bit on the obvious side.",
	},
	{"Remember The Titans",
	 "This is the name of a football movie, but also quite appropriate here, since you are learning of the ancient legend of the Ice Titans!",
	},
	{"Rocket Sauce",
	 "A Tenacious D reference!  Rocket Sauce is the preferred beverage of Tenacious D, and it really gets you rocking.",
	},
	{"Rosetta Roper",
	 "This is not a reference to the Rosetta Stone, it's just a woman's name that has the same beginning sound as the word \"rope\", sort of like her husband Rupert.  Anyway, if you talk to Rosetta after finishing all her quests, she says \"No soup for you!\", which is a reference to the Soup Nazi character from the TV show Seinfeld.",
	},
	{"Rosie O'Bomber",
	 "This is of course a reference to talk show host Rosie O'Donnell.  There's no reason for it other than that it's very hard to come up with names for these monsters.  And it's a rose, that fires bombs.",
	},
	{"Rupert Roper",
	 "Rupert's comment \"That was brisk, baby\" is a reference, that I use often in daily life unwittingly, to a series of TV commercials for Lipton Brisk Iced Tea, in which that line was used obnoxiously.  He also points out the oddness of the avalanche that got him - it's the only lump of snow in the entire game more than an inch deep.",
	},
	{"Sharona",
	 "All the Shroomulans have names that almost/sorta begin with SHR.  Sharona's is the most questionable of the bunch.  It's a very minimal nod to the TV series Monk, where Sharona is the name of Monk's nurse.  It could also refer to the song \"My Sharona.\"  But it doesn't.",
	},
	{"Sharpest Tool, The",
	 "This quest's name is a very slight allusion to the phrase \"he's not the sharpest tool in the shed.\"",
	},
	{"Show Him The Ropes",
	 "This is a common phrase meaning to teach someone the basics of something.  In this game, it's being used literally - go find some ropes and show them to the balloonist!  Also give them to him, once you're done showing them.  The phrase actually comes from sailing - new sailors had to be \"shown the ropes\" so that they learned which ropes on the ship did what.",
	},
	{"Shroom",
	 "Hamumu reference!  Since you are the young Dr. Lunatic, you can turn monsters into Shrooms, something that will be handy later in life.  I had an idea to make all the spells reflect Dr. Lunatic's future abilites, but that was too hard, so instead there is just this, Boneheads, and Cryozoid.  Shrooms are of course a monster from Dr. Lunatic (also in Kid Mystic, but called Mushies there at publisher request - because \"Shrooms\" can also be a reference to hallucinogenic mushrooms).",
	},
	{"Smart Sauce",
	 "The description of this potion is a reference to a very old Saturday Night Live skit, which was a commercial for a product that was both a floor polish and a dessert topping.",
	},
	{"Smith, Mrs.",
	 "We never find out Mrs. Smith's first name.  That's because it's Magic.  Her name is Magic Smith and she's the Magicsmith.",
	},
	{"Static",
	 "The description of this skill is a reference to an actual thing you can do - rub a balloon on your hair to charge it up and make it stand up straight.  It's just a weak attempt to offer some explanation as to why your axe would shoot lightning.  Most games offer absolutely ridiculous high-minded explanations of why you can do the completely nonsense things you do, so this like many other skill descriptions really just parodies that.",
	},
	{"Stockboy",
	 "A Hamumu reference!  This quest name refers of course to the Hamumu game Stockboy.  Also to the fact that by fetching axes for the shop, you are in fact acting as a stockboy.",
	},
	{"Stone Rose",
	 "This is a reference to the band The Stone Roses.  I don't even know what their music is like.  Did you know one of the Castlevania games also has a monster called a Stone Rose?  I believe it's for the same reason.  Or perhaps is there a deeper reference yet?",
	},
	{"Stone Soup",
	 "Surely you've heard of Stone Soup?  I believe there's a children's book of that name, and I know there's a card game.  Maybe it's a classic fable.  Anyway, I wanted a potion that made you more resistant to harm, and the name Stone Soup fits very nicely.",
	},
	{"Taylor's Knits",
	 "This guy is the tailor in the game, hence his name being Taylor.  Kind of obvious, you could say.  Taylor's Knits is a reference to \"tailor knit\", which is a term that is snootily applied to some articles of clothing, and most likely doesn't mean anything at all.",
	},
	{"Terrible Sock Monkeys",
	 "This description of the battle \"Sock It To Ya\" is a reference to the TV show Firefly, in which Captain Mal asks Kaylee, after seeing the mess in the engine room, \"What happened here?  Were there monkeys?  Terrible space monkeys?\"",
	},
	{"Thing Of Majig",
	 "When said quickly, this is 'Thingamajig'.  Just like its brethren, the Watch Of Makalit and the Thing Of Mabob, it is a completely meaningless object, a spoof on all those arbitrary magical artifacts in games (like, I confess, the Binding Crystal) which could be anything.  It doesn't matter what they are, they're just the things you need to finish the quest.  See also \"MacGuffins.\"",
	},
	{"Thuggin' Love",
	 "This battle's name is a reference to the cartoon show \"The Boondocks\" (based on the comic strip), in which that is the title of a song you hear in the background of many episodes.",
	},
	{"Tinny Tim",
	 "Tinny refers to the fact that this enemy is obviously a type of Tin Soldier.  But it's called Tinny Tim in reference to the character Tiny Tim from Dickens' A Christmas Carol.",
	},
	{"To The Pain!",
	 "The name of this Arena match is a reference to the book and movie \"The Princess Bride\".  In it, Westley threatens to engage the prince in a duel \"to the pain\" as opposed to \"to the death\".  There is an extensive description of what this means in the highly recommended source material.  \"The Cliffs Of Insanity\" is also a Princess Bride reference.",
	},
	{"Toasties",
	 "An original invention, though I am dead certain you'll find many generic cereal products bearing the name, among other things.  That was sort of the idea, to make it a brand name for the little fire buddies.",
	},
	{"Toy Story 2",
	 "One of the more obvious references in the history of the world.  Second story of the Toy Factory, Toy Story 2, movie, you get it.",
	},
	{"Trigun",
	 "This enemy is named after the anime series of the same name.  He has no other relationship to it.  He just happens to fire tri-shots.  The Arena battle against him is a further reference to the show - Vash The Stampede was the main character, and Knives was the villain.",
	},
	{"Tsarina, Tina",
	 "Three layers to this joke, none very funny.  First, Tina rhymes with Arena, and that tends to be how I decide what to name people (see Healiana, Taylor, Woody, Mrs. Smith, and more).  Second, \"Tina Tsarina\" is exactly the same sound as \"Tina's Arena\".  And thirdly and most subtly, Tina is a reference to Tina Turner, who played the queen of the Thunderdome (a gladiatorial arena) in Mad Max 3.",
	 },
	{"Vampirism",
	 "There's no reference in this skill (other than that vampires suck life, as does this skill), but I wanted to comment on the description and how it frustratedly proclaims there's no sense to it.  That's because lots of games have a skill like this and it DOESN'T MAKE SENSE!",
	},
	{"Whirl",
	 "This skill is a total ripoff of the Whirlwind skill from Diablo 2.  Which is a really silly skill, hence its appropriateness in this game!",
	},
	{"Woodsman, Woody",
	 "Though it sounds like a play on Woody Woodpecker, that's actually just a coincidence.  In fact, I had conceived this character early on and thought of him simply as \"The Woodsman\".  When it came to putting him in the game, I needed a name for him, so the thing that came immediately to mind was of course Woody.  What else would it be?",
	},
};

char *All_EntryName(byte n)
{
	if(n<0 || n>99)
		return allusion[0].name;
	else
		return allusion[n].name;
}

char *All_EntryDesc(byte n)
{
	if(n<0 || n>99)
		return allusion[0].desc;
	else
		return allusion[n].desc;
}